'use strict';

var _chai = require('chai');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _reactHtmlAttributes = require('./react-html-attributes.json');

var _reactHtmlAttributes2 = _interopRequireDefault(_reactHtmlAttributes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } } /* global
                                                                                                                                                                                                      describe, it
                                                                                                                                                                                                    */

function isArrayOfStrings(array) {
  return array.every(function (item) {
    return typeof item === 'string';
  });
}

function areArraysUnique(array) {
  return array.every(function (items) {
    return items.length === _lodash2.default.uniq(items).length;
  });
}

function areArraysApatheticallySorted(array) {
  return array.every(function (items) {
    var _ref;

    return (_ref = /^[a-z-]+$/).test.apply(_ref, _toConsumableArray(items.map(function (item) {
      return item[0];
    })));
  });
}

describe('react-html-attributes', function () {
  var attributeLists = _lodash2.default.values(_reactHtmlAttributes2.default);

  it('should have a list of all available names', function () {
    (0, _chai.expect)(_lodash2.default.flatten(attributeLists)).to.satisfy(isArrayOfStrings);
  });

  it('should have a list of all unique names', function () {
    (0, _chai.expect)(attributeLists).to.satisfy(areArraysUnique);
  });

  it('should have a list of apathetically sorted names', function () {
    (0, _chai.expect)(attributeLists).to.satisfy(areArraysApatheticallySorted);
  });
});